package org.jboss.seam.example.booking;

import static org.jboss.seam.ScopeType.SESSION;

import java.util.List;

import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.contexts.Contexts;
import org.jboss.seam.log.Log;
import org.jboss.seam.security.Credentials;
import org.jivesoftware.smack.XMPPException;

@Stateless
@Name("authenticator")
public class AuthenticatorAction 
    implements Authenticator
{
    @PersistenceContext (unitName = "bookingDatabase") 
    private EntityManager em;

    @In(required=false)   
    @Out(required=false, scope = SESSION)
    private User user;
    
    @Logger private Log log;
    @In Credentials credentials;
    
    @In(required=false)   
    @Out(required=false, scope = SESSION)
    private MyXMPPManager xmppm;
   
    public boolean authenticate()
    {
    	log.info("authenticating {0}", credentials.getUsername());
        Boolean result = false;
        
        try
        {
          UserManager usermanager = new UserManager();	
           User user = usermanager.getUserwithname(credentials.getUsername());
			if (user != null) {
				result = validatePassword(user.getPassword(),credentials.getPassword());
				if (result == true) {
					//String server = PropertyReader.getProperty("server");
					//String port = PropertyReader.getProperty("port");
					//XMPPManager xmppm = new XMPPManager(server,Integer.parseInt(port));
					int port = 5222;
					xmppm = new MyXMPPManager("la110033",port);
					xmppm.performLogin(credentials.getUsername(),credentials.getPassword());
					xmppm.getalldata();
					}
				Contexts.getSessionContext().set("user", user);
			}
        }
        catch (XMPPException ex)

        {
        	log.error("Error logging in presence server!");
        	result = false;
        }
        catch (NoResultException ex)

        {
        	result = false;
        	log.error("Error fetching user details for authentication!");  
        }
        if(result)
        	return true;
        else
        	return false;
    }
    
private boolean validatePassword(String dbpassword,String enteredpwd) {
		
		if(dbpassword.equals(enteredpwd))
			return true;
		return false;
	}
	
	public boolean logoff(){
		//xmppm.logout();
		return true;
		
	}
    
}
